// ---------------------------------------------------------------------------
// asm.h
// ===========================================================================
#if !defined(AFX_ASM_H__A9DB83DB_A9FD_11D0_BFD1_444553540000__INCLUDED_)
#define AFX_ASM_H__A9DB83DB_A9FD_11D0_BFD1_444553540000__INCLUDED_


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef int (__cdecl *pfnCOMPARE)(const void* pElem1, const void* pElem2);

#if defined(__cplusplus)
extern "C" {
#endif

// Does a binary search for pTarget.
// If compare is not null, will use the user-defined compare routine
// to compare specified element information against pTarget, otherwise
// callee will adjust the offset into the element (if the element is bigger
// then 4 bytes) before calling and re-adjust ptr returned (if not NULL)
LPVOID __stdcall BinarySearch(IN LPCVOID pTarget, IN LPCVOID pArray, IN const DWORD  dwArrayCount,
		IN const DWORD	 dwElemSize, IN pfnCOMPARE compare);


// returns the CRC32 table used by Crc32.
DWORD* __stdcall GetCrc32Table();


// creates a CRC32 value from specified buffer with length.
// Also seeds the CRC incoming and outgoing value.
ULONG __stdcall Crc32(IN ULONG crc, IN LPCVOID pBuffer, IN unsigned Len);


// ZIP LIBRARY ROUTINES
BOOL	__stdcall zaOpenArchive(void* Instance, LPCTSTR lpszFileSpec);
void	__stdcall zaCloseArchive(void* Instance);
void* __stdcall zaLoadEntryByIndex(void* Instance, int idx, HGLOBAL* BufHandle);

#if defined(__cplusplus)
}
#endif


// ===========================================================================
#endif // #define AFX_ASM_H__A9DB83DB_A9FD_11D0_BFD1_444553540000__INCLUDED_
